Index: libroar/stream.c
===================================================================
--- libroar/stream.c	(revision 6052)
+++ libroar/stream.c	(revision 0)
@@ -1,67 +1,18 @@
 //stream.c:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of libroar a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  libroar is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- *  NOTE for everyone want's to change something and send patches:
- *  read README and HACKING! There a addition information on
- *  the license of this document you need to read before you send
- *  any patches.
- *
- *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
- *  or libpulse*:
- *  The libs libroaresd, libroararts and libroarpulse link this lib
- *  and are therefore GPL. Because of this it may be illigal to use
- *  them with any software that uses libesd, libartsc or libpulse*.
- */
 
 #include "libroar.h"
 
-int roar_stream_connect(struct roar_connection * con, struct roar_stream * s, int dir, int mixer) {
- struct roar_libroar_config * config = roar_libroar_get_config();
- struct roar_stream  ms;
+int roar_stream_connect (struct roar_connection * con, struct roar_stream * s, int dir) {
  struct roar_message m;
 
  s->dir = dir;
 
- memset(&m,  0, sizeof(m));
- memcpy(&ms, s, sizeof(ms));
-
  m.cmd     = ROAR_CMD_NEW_STREAM;
- m.stream  = mixer;
+ m.stream  = -1;
  m.pos     = 0;
 
- if ( config != NULL ) {
-  if ( config->info.rate )
-   ms.info.rate = config->info.rate;
-  if ( config->info.bits )
-   ms.info.bits = config->info.bits;
-  if ( config->info.channels )
-   ms.info.channels = config->info.channels;
-  if ( config->info.codec )
-   ms.info.codec = config->info.codec;
- }
+ roar_stream_s2m(s, &m);
 
- roar_stream_s2m(&ms, &m);
-
- if ( roar_req3(con, &m, NULL) != 0 )
+ if ( roar_req(con, &m, NULL) != 0 )
   return -1;
 
@@ -81,20 +32,17 @@
                      unsigned int channels, unsigned int bits, unsigned int codec) {
 
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( bits > ROAR_BITS_MAX ) {
-  roar_err_set(ROAR_ERROR_RANGE);
-  return -1;
- }
 
  s->fh         = -1;
  s->id         = -1;
- s->pos        =  0;
+ s->pos        = 0;
  s->pos_rel_id = -1;
 
  s->dir        = ROAR_DIR_DEFAULT;
+
+ s->datalen    = 0;
+ s->offset     = 0;
+
+ s->database   = NULL;
+ s->dataoff    = NULL;
 
  s->info.rate     = rate;
@@ -103,136 +51,12 @@
  s->info.codec    = codec;
 
- return 0;
-}
-
-int roar_stream_new_by_info (struct roar_stream * s, const struct roar_audio_info * info) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
+ if ( bits > ROAR_BITS_MAX )
   return -1;
- }
-
- if ( info->bits > ROAR_BITS_MAX ) {
-  roar_err_set(ROAR_ERROR_RANGE);
-  return -1;
- }
-
- s->fh         = -1;
- s->id         = -1;
- s->pos        =  0;
- s->pos_rel_id = -1;
-
- s->dir        = ROAR_DIR_DEFAULT;
-
- s->info = *info;
 
  return 0;
 }
 
-int roar_stream_set_rel_id(struct roar_stream * s, int id) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- s->pos_rel_id = id;
-
- return 0;
-}
-
-int roar_stream_get_rel_id(struct roar_stream * s) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- return s->pos_rel_id;
-}
-
-int roar_stream_new_by_id(struct roar_stream * s, int id) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( roar_stream_new_empty(s) == -1 )
-  return -1;
-
- return roar_stream_set_id(s, id);
-}
-
-int roar_stream_new_empty(struct roar_stream * s) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- return roar_stream_new(s, 0, 0, 0, 0);
-}
-
-int roar_stream_set_id (struct roar_stream * s, int id) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- s->id = id;
-
- return 0;
-}
-
-int roar_stream_get_id (struct roar_stream * s) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- return s->id;
-}
-
-int roar_stream_set_fh (struct roar_stream * s, int fh) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- s->fh = fh;
-
- return 0;
-}
-
-int roar_stream_get_fh (struct roar_stream * s) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- return s->fh;
-}
-
-int roar_stream_set_dir (struct roar_stream * s, int dir) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- s->dir = dir;
-
- return 0;
-}
-
-int roar_stream_get_dir (struct roar_stream * s) {
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- return s->dir;
-}
-
-
 int roar_stream_exec    (struct roar_connection * con, struct roar_stream * s) {
  struct roar_message m;
-
- memset(&m,  0, sizeof(m));
 
  m.cmd     = ROAR_CMD_EXEC_STREAM;
@@ -249,8 +73,15 @@
 }
 
-int roar_stream_connect_to (struct roar_connection * con, struct roar_stream * s, int type, char * host, int port) {
+
+int roar_stream_add_data (struct roar_connection * con, struct roar_stream * s, char * data, size_t len) {
  struct roar_message m;
 
- if ( roar_stream_connect_to_ask(con, s, type, host, port) == -1 )
+ m.cmd     = ROAR_CMD_ADD_DATA;
+ m.stream  = s->id;
+ m.datalen = len;
+
+// if ( roar_req(con, &m, (void**)&data) == -1 )
+//  return -1;
+ if ( roar_send_message(con, &m, data) != 0 )
   return -1;
 
@@ -263,669 +94,4 @@
 }
 
-int roar_stream_connect_to_ask (struct roar_connection * con, struct roar_stream * s, int type, char * host, int port) {
- struct roar_message m;
- int len = 0;
-
- if ( host == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- ROAR_DBG("roar_stream_connect_to_ask(*): Ask the server to connect to: %s:%i", host, port);
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_CON_STREAM;
- m.stream  = s->id;
- m.pos     = 0;
-
- m.data[0] = 0;
- m.data[1] = type;
- ((uint16_t*)&(m.data))[1] = ROAR_HOST2NET16(port);
-
- len = strlen(host);
-
- if ( len > 76 ) {
-  roar_err_set(ROAR_ERROR_NAMETOOLONG);
-  return -1;
- }
-
- strncpy(&(m.data[4]), host, len);
-
- m.datalen = len + 4;
-
- if ( roar_send_message(con, &m, NULL) == -1 )
-  return -1;
-
- return 0;
-}
-
-int roar_stream_connect_to_advanced (struct roar_connection * con, struct roar_stream * s,
-                                     int version, int ask_only, uint_least32_t flags,
-                                     int socket_type, ssize_t socket_len, const void * socketaddr,
-                                     int transport_protocol, ssize_t tranport_len, const void * transportsetup,
-                                     uint16_t clientsetup_flags, struct roar_client * clientsetup) {
- struct roar_message m;
- char buf[80];
- int port;
- uint16_t tmp;
-
- if ( con == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( transport_protocol == ROAR_PROTO_NONE && (tranport_len != -1 || transportsetup ) ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return -1;
- }
-
- if ( !((s == NULL) ^ (clientsetup == NULL)) ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return -1;
- }
-
- switch (version) {
-  case 0:
-    if ( transport_protocol != ROAR_PROTO_NONE || s == NULL) {
-     roar_err_set(ROAR_ERROR_INVAL);
-     return -1;
-    }
-    switch (socket_type) {
-     case ROAR_SOCKET_TYPE_TCP:
-     case ROAR_SOCKET_TYPE_UDP:
-       if ( socket_len != 6 ) {
-        roar_err_set(ROAR_ERROR_FAULT);
-        return -1;
-       }
-       snprintf(buf, sizeof(buf), "%i.%i.%i.%i",
-                ((const unsigned char*)socketaddr)[0], ((const unsigned char*)socketaddr)[1],
-                ((const unsigned char*)socketaddr)[2], ((const unsigned char*)socketaddr)[3]);
-       port = ROAR_NET2HOST16(((const uint16_t*)socketaddr)[3]);
-       if ( roar_stream_connect_to_ask(con, s, socket_type, buf, port) == -1 )
-        return -1;
-      break;
-     case ROAR_SOCKET_TYPE_DECNET:
-       if ( socket_len < 3 ) {
-        roar_err_set(ROAR_ERROR_FAULT);
-        return -1;
-       }
-       tmp  = ((const uint16_t*)socketaddr)[0];
-       port = ((const unsigned char*)socketaddr)[2];
-       snprintf(buf, sizeof(buf), "%i.%i::%*s", tmp >> 10, tmp & 0x03FF, (int)socket_len - 3, (const char*)socketaddr + 3);
-       if ( roar_stream_connect_to_ask(con, s, socket_type, buf, port) == -1 )
-        return -1;
-      break;
-     default:
-       if ( ((const char *)socketaddr)[socket_len-1] == 0 ) {
-        if ( socket_len > sizeof(buf) ) {
-         roar_err_set(ROAR_ERROR_MSGSIZE);
-         return -1;
-        }
-        memcpy(buf, socketaddr, socket_len);
-        if ( roar_stream_connect_to_ask(con, s, socket_type, buf, 0) == -1 )
-         return -1;
-       } else {
-        roar_err_set(ROAR_ERROR_FAULT);
-        return -1;
-       }
-      break;
-    }
-   break;
-  default:
-    roar_err_set(ROAR_ERROR_NSVERSION);
-    return -1;
-   break;
- }
-
-
- if ( ask_only )
-  return 0;
-
- if ( roar_recv_message(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd == ROAR_CMD_OK )
-  return 0;
- return -1;
-}
-
-int roar_stream_passfh  (struct roar_connection * con, struct roar_stream * s, int fh) {
- struct roar_message m;
- int confh;
-
- if ( con == NULL || s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( fh < 0 ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return -1;
- }
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_PASSFH;
- m.stream  = s->id;
- m.pos     = 0;
- m.datalen = 0;
-
- ROAR_DBG("roar_stream_passfh(con=%p{...}, s={.id=%i,...}, fh=%i) = ?", con, s->id, fh);
-
- roar_libroar_nowarn();
- if ( (confh = roar_get_connection_fh(con)) == -1 ) {
-  roar_libroar_warn();
-  return -1;
- }
- roar_libroar_warn();
-
- if ( roar_send_message(con, &m, NULL) == -1 ) {
-  ROAR_DBG("roar_stream_passfh(con=%p{...}, s={.id=%i,...}, fh=%i) = -1 // can not send message", con, s->id, fh);
-  return -1;
- }
-
- ROAR_DBG("roar_stream_passfh(*): msg send");
-
- if ( roar_socket_send_fh(confh, fh, NULL, 0) == -1 )
-  return -1;
-
- ROAR_DBG("roar_stream_passfh(*): fh send");
-
- if ( roar_recv_message(con, &m, NULL) == -1 )
-  return -1;
-
- ROAR_DBG("roar_stream_passfh(*): mes recved");
-
- if ( m.cmd == ROAR_CMD_OK )
-  return 0;
-
- return -1;
-}
-
-int roar_stream_attach_simple (struct roar_connection * con, struct roar_stream * s, int client) {
- struct roar_message m;
- uint16_t * info = (uint16_t *) m.data;
- int i;
-
- if ( con == NULL || s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( client < 0 ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return -1;
- }
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_ATTACH;
- m.stream  = s->id;
- m.pos     = 0;
- m.datalen = 6;
-
- info[0] = 0;
- info[1] = ROAR_ATTACH_SIMPLE;
- info[2] = client;
-
- for (i = 0; i < m.datalen/2; i++) {
-  info[i] = ROAR_HOST2NET16(info[i]);
- }
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- return 0;
-}
-
-int roar_stream_get_info (struct roar_connection * con, struct roar_stream * s, struct roar_stream_info * info) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
- int i;
-
- if ( con == NULL || s == NULL || info == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_GET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = 4;
- m.pos     = 0;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_INFO; // stream
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_HOST2NET16(data[i]);
- }
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_NET2HOST16(data[i]);
- }
-
- if ( m.datalen < 7*2 ) {
-  roar_err_set(ROAR_ERROR_MSGSIZE);
-  return -1;
- }
-
- if ( data[0] != 0 || data[1] != 1 ) {
-  roar_err_set(ROAR_ERROR_NSVERSION);
-  return -1;
- }
-
- memset(info, 0, sizeof(struct roar_stream_info));
- info->mixer = -1;
- info->role  = ROAR_ROLE_UNKNOWN;
-
- info->block_size     = data[2];
- info->pre_underruns  = data[3];
- info->post_underruns = data[4];
- info->codec          = data[5];
- info->flags          = data[6];
- info->delay          = data[7]*1000;
-
- if ( m.datalen < 9*2 ) {
-  info->state         = ROAR_STREAMSTATE_UNKNOWN;
-  return 0;
- } else {
-  info->state         = data[8];
- }
-
- if ( m.datalen < 10*2 ) {
-  return 0;
- } else {
-  info->flags        |= ((uint32_t)data[9]) << 16;
- }
-
- if ( m.datalen < 11*2 ) {
-  return 0;
- } else {
-  info->mixer         = data[10];
- }
-
- if ( m.datalen < 12*2 ) {
-  return 0;
- } else {
-  info->role          = data[11];
- }
-
- return 0;
-}
-
-int roar_stream_get_name (struct roar_connection * con, struct roar_stream * s, char * name, size_t len) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
-
- if ( con == NULL || s == NULL || name == NULL || len == 0 ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- name[0] = 0; // just in case...
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_GET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = 4;
- m.pos     = 0;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_NAME; // stream
-
- data[0] = ROAR_HOST2NET16(data[0]);
- data[1] = ROAR_HOST2NET16(data[1]);
-
- ROAR_DBG("roar_stream_get_name(*) = ?");
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- ROAR_DBG("roar_stream_get_name(*) = ?");
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- ROAR_DBG("roar_stream_get_name(*) = ?");
-
- if ( m.datalen < 4 ) {
-  roar_err_set(ROAR_ERROR_MSGSIZE);
-  return -1;
- }
-
- data[0] = ROAR_NET2HOST16(data[0]);
- data[1] = ROAR_NET2HOST16(data[1]);
-
- ROAR_DBG("roar_stream_get_name(*) = ?");
-
- if ( data[0] != 0 ) {
-  roar_err_set(ROAR_ERROR_NSVERSION);
-  return -1;
- }
-
- if ( data[1] != (uint16_t)ROAR_STREAM_PARA_NAME ) {
-  roar_err_set(ROAR_ERROR_TYPEMM);
-  return -1;
- }
-
- m.datalen -= 4;
-
- len--;
-
- if ( len > m.datalen )
-  len = m.datalen;
-
- strncpy(name, ((char*)m.data)+4, len);
- name[len] = 0;
-
- ROAR_DBG("roar_stream_get_name(*) = 0");
-
- return 0;
-}
-
-int roar_stream_get_chanmap (struct roar_connection * con, struct roar_stream * s, char * map, size_t * len) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p, map=%p, len=%p) = ?", con, s, map, len);
-
- if ( con == NULL || s == NULL || map == NULL || len == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( *len == 0 ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return -1;
- }
-
- memset(&m, 0, sizeof(m));
-
- m.cmd     = ROAR_CMD_GET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = 2*2;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_CHANMAP;
-
- data[0] = ROAR_HOST2NET16(data[0]);
- data[1] = ROAR_HOST2NET16(data[1]);
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p{.id=%i}, map=%p, len=%p) = ?", con, s, s->id, map, len);
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p{.id=%i}, map=%p, len=%p) = ?", con, s, s->id, map, len);
-
- if ( m.datalen < 4 ) {
-  roar_err_set(ROAR_ERROR_MSGSIZE);
-  return -1;
- }
-
- data[0] = ROAR_NET2HOST16(data[0]);
- data[1] = ROAR_NET2HOST16(data[1]);
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p{.id=%i}, map=%p, len=%p) = ?", con, s, s->id, map, len);
-
- if ( data[0] != 0 ) {
-  roar_err_set(ROAR_ERROR_NSVERSION);
-  return -1;
- }
-
- if ( data[1] != ROAR_STREAM_PARA_CHANMAP ) {
-  roar_err_set(ROAR_ERROR_TYPEMM);
-  return -1;
- }
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p{.id=%i}, map=%p, len=%p) = ?", con, s, s->id, map, len);
-
- m.datalen -= 4;
-
- if ( m.datalen > *len ) {
-  roar_err_set(ROAR_ERROR_NOMEM);
-  return -1;
- }
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p{.id=%i}, map=%p, len=%p) = ?", con, s, s->id, map, len);
-
- memcpy(map, &(m.data[4]), m.datalen);
-
- *len = m.datalen;
-
- ROAR_DBG("roar_stream_get_chanmap(con=%p, s=%p{.id=%i}, map=%p, len=%p) = 0", con, s, s->id, map, len);
- return 0;
-}
-
-int roar_stream_set_chanmap (struct roar_connection * con, struct roar_stream * s, char * map, size_t   len) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
-
- if ( con == NULL || s == NULL || map == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( len == 0 ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return 0;
- }
-
- memset(&m, 0, sizeof(m));
-
- m.cmd     = ROAR_CMD_SET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = 2*2 + len;
-
- if ( m.datalen > sizeof(m.data) )
-  return -1;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_CHANMAP;
-
- data[0] = ROAR_HOST2NET16(data[0]);
- data[1] = ROAR_HOST2NET16(data[1]);
-
- memcpy(&(m.data[4]), map, len);
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- return 0;
-}
-
-
-int roar_stream_set_flags (struct roar_connection * con, struct roar_stream * s, uint32_t flags, int action) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
- int i;
-
- if ( con == NULL || s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_SET_STREAM_PARA;
- m.stream  = s->id;
- m.pos     = 0;
-
- if ( flags & 0xFFFF0000 ) {
-  m.datalen = 2*5;
- } else {
-  m.datalen = 2*4;
- }
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_FLAGS; // flags
- data[2] = action;
- data[3] = flags & 0x0000FFFF;
-
- if ( flags & 0xFFFF0000 ) {
-  data[4] = (flags & 0xFFFF0000) >> 16;
- }
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_HOST2NET16(data[i]);
- }
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- return 0;
-}
-
-int roar_stream_set_role  (struct roar_connection * con, struct roar_stream * s, int role) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
- int i;
-
- if ( con == NULL || s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_SET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = 6;
- m.pos     = 0;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_ROLE; // flags
- data[2] = role;
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_HOST2NET16(data[i]);
- }
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- return 0;
-}
-
-int roar_stream_get_rpg   (struct roar_connection * con, struct roar_stream * s, struct roar_stream_rpg * rpg) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
- size_t i;
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_GET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = 2*2;
- m.pos     = 0;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_RPG; // flags
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_HOST2NET16(data[i]);
- }
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_NET2HOST16(data[i]);
- }
-
- if ( m.datalen != 10 ) {
-  roar_err_set(ROAR_ERROR_MSGSIZE);
-  return -1;
- }
-
- if ( data[0] != 0 ) {
-  roar_err_set(ROAR_ERROR_NSVERSION);
-  return -1;
- }
-
- if ( data[1] != ROAR_STREAM_PARA_RPG ) {
-  roar_err_set(ROAR_ERROR_BADRQC);
-  return -1;
- }
-
- memset(rpg, 0, sizeof(struct roar_stream_rpg));
-
- rpg->mode = data[2];
- rpg->mul  = data[3];
- rpg->div  = data[4];
-
- if ( rpg->mode == 0xFFFF )
-  rpg->mode = -1;
-
- return 0;
-}
-
-int roar_stream_set_rpg   (struct roar_connection * con, struct roar_stream * s, const struct roar_stream_rpg * rpg) {
- struct roar_message m;
- uint16_t * data = (uint16_t *) m.data;
- size_t i;
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_SET_STREAM_PARA;
- m.stream  = s->id;
- m.datalen = (2+3)*2;
- m.pos     = 0;
-
- data[0] = 0; // Version and reserved
- data[1] = ROAR_STREAM_PARA_RPG; // flags
- data[2] = rpg->mode;
- data[3] = rpg->mul;
- data[4] = rpg->div;
-
- for (i = 0; i < m.datalen/2; i++) {
-  data[i] = ROAR_HOST2NET16(data[i]);
- }
-
- if ( roar_req(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd != ROAR_CMD_OK )
-  return -1;
-
- return 0;
-}
-
-#ifdef DEBUG
-static inline void _roar_debug_audio_info_print (struct roar_audio_info * info) {
- ROAR_DBG("_roar_debug_audio_info_print(*): Rate    : %i", info->rate);
- ROAR_DBG("_roar_debug_audio_info_print(*): Channels: %i", info->channels);
- ROAR_DBG("_roar_debug_audio_info_print(*): Bits    : %i", info->bits);
- ROAR_DBG("_roar_debug_audio_info_print(*): Codec   : %i", info->codec);
-}
-#endif
 
 #define _ROAR_STREAM_MESSAGE_LEN ((5+1)*4)
@@ -935,8 +101,6 @@
  int i;
 
- if ( s == NULL || m == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
+ if ( !(s && m) )
   return -1;
- }
 
  m->datalen = _ROAR_STREAM_MESSAGE_LEN;
@@ -953,11 +117,6 @@
   data[i] = ROAR_HOST2NET32(data[i]);
 
-#ifdef DEBUG
  ROAR_DBG("roar_stream_s2m(*): s->info:");
- _roar_debug_audio_info_print(&(s->info));
-#endif
-
- m->pos   = s->pos;
- m->pos64 = s->pos;
+ roar_debug_audio_info_print(&s->info);
 
  return 0;
@@ -967,19 +126,9 @@
  int i;
 
- if ( s == NULL || m == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
+ if ( !(s && m) )
   return -1;
- }
 
- if ( m->datalen != _ROAR_STREAM_MESSAGE_LEN ) {
-  roar_err_set(ROAR_ERROR_MSGSIZE);
+ if ( m->datalen != _ROAR_STREAM_MESSAGE_LEN )
   return -1;
- }
-
- if ( m->flags & ROAR_MF_LSPOS ) {
-  s->pos = m->pos64;
- } else {
-  s->pos = m->pos;
- }
 
  data = (uint32_t*) m->data;
@@ -988,5 +137,4 @@
   data[i] = ROAR_NET2HOST32(data[i]);
 
- s->id            = m->stream;
  s->dir           = data[0];
  s->pos_rel_id    = data[1];
